;===============================================================================
;
; alternative fixed dice 1.0
;
; - change the damage algorithm of the fixed dice special effect
;
;===============================================================================
header
hirom

;===============================================================================
;
; main
;
;===============================================================================
org     $C24158

;-------------------------------------------------------------------------------
main:
;-------------------------------------------------------------------------------

    ;get dice 1
        JSR dice_random         ;get random value: [0, 5]
        PHA                     ;save it
        STA $B7                 ;save dice 1 for animation

    ;get dice 2
        JSR dice_random         ;get random value: [0, 5]
        PHA                     ;save it
        ASL                     ;adjust bits position
        ASL
        ASL
        ASL
        ORA $B7                 ;add with dice 1 number
        STA $B7                 ;save dice 1 and dice 2 animation

    ;get dice 3
        JSR dice_random         ;get random value: [0, 5]
        PHA                     ;save it
        STA $B6                 ;save dice 3 for animation

    ;main
        JSR dice_sort           ;sort dice numbers
        JSR dice_choose         ;choose dice
        TAX                     ;X = choosed dice
        JSL dice_damage         ;setup damage

    ;exit
        PLA
        PLA
        PLA
        RTS

;-------------------------------------------------------------------------------
dice_random:
;
; - get random number in [0, 5] range 
;-------------------------------------------------------------------------------

    ;get random number
        LDA #$06                ;max random number
        JSR $4B65               ;random: [0, A -1] 
        RTS

;-------------------------------------------------------------------------------
dice_sort:
; - sort dices
; - $03,S   dice number 1
; - $04,S   dice number 2
; - $05,S   dice number 3
;-------------------------------------------------------------------------------

    ;check dice 1 and 2
        LDA $03,S               ;dice 1
        CMP $04,S               ;dice 2
        BCC .skip12

    ;swap dice 1 and 2
        XBA                     ;backup dice 1
        LDA $04,S               ;dice 2
        STA $03,S               ;save as dice 1
        XBA                     ;dice 1
        STA $04,S               ;save as dice 2
.skip12

    ;check dice 1 and 3
        LDA $03,S               ;dice 1
        CMP $05,S               ;dice 3
        BCC .skip13

    ;swap dice 1 and 3
        XBA                     ;backup dice 1
        LDA $05,S               ;dice 3
        STA $03,S               ;save as dice 1
        XBA                     ;dice 1
        STA $05,S               ;save as dice 3
.skip13

    ;check dice 2 and 3
        LDA $04,S               ;dice 2
        CMP $05,S               ;dice 3
        BCC .skip23

    ;swap dice 1 and 3
        XBA                     ;backup dice 2
        LDA $05,S               ;dice 3
        STA $04,S               ;save as dice 2
        XBA                     ;dice 2
        STA $05,S               ;save as dice 3
.skip23

    ;exit
        RTS

;-------------------------------------------------------------------------------
dice_choose:
; - get dice based on setup game
; - $03,S   dice number 1
; - $04,S   dice number 2
; - $05,S   dice number 3
;-------------------------------------------------------------------------------

    ;choose game
        LDA $11A8               ;hit rate as game selection
        DEC                     
        AND #$03                ;A = [0, 3]

    ;execute table
        ASL                     ;adjust to table
        TAX
        JMP (dice_game,X)       ;get dice for game

;-------------------------------------------------------------------------------
dice_game:
;-------------------------------------------------------------------------------

    ;table of pointer to get dice
        dw game0
        dw game1
        dw game2
        dw game3

game0:
    ;get random number
        LDA #$03                ;max random number
        JSR $4B65               ;random: [0, A -1]
        INC
        ASL
        TAX
        JMP (dice_game,X)

game1:
    ;return lowest dice
        LDA $03,S               ;lowest dice
        RTS

game2:
    ;get middle dice
        LDA $04,S               ;middle dice
        RTS

game3:
    ;get highest dice
        LDA $05,S               ;highest dice
        RTS

warnpc  $C241E5

;===============================================================================
;
; dice values
;
;===============================================================================
org     $C3FB50
dice_value:

    dw  #$03E8                  ;number 1: 1000
    dw  #$07D0                  ;number 2: 2000
    dw  #$0BB8                  ;number 3: 3000
    dw  #$0FA0                  ;number 4: 4000
    dw  #$1388                  ;number 5: 5000
    dw  #$1770                  ;number 6: 6000

warnpc  $C3FB5C

;===============================================================================
;
; setup damage
;
; X in      = choosed dice [0, 5]
;===============================================================================
org     $C3FB5C
dice_damage:

    ;setup damage
        TXA                     ;choosed dice
        ASL                     ;adjust to table
        TAX                     ;X = dice number
        REP #$20                ;mode 2AB
        LDA.l dice_value,X      ;get damage based on table
        STA $11B0               ;save damage
        SEP #$20                ;mode 1AB

    ;setup flags
        STZ $3414               ;avoid damage randomness
        LDA #$60                ;ignore defense, no split damage
        TSB $11A2               ;setup flags
        LDA #$20                ;can't dodge
        TSB $11A4               ;setup flags

    ;setup animation
        LDA $B5                 ;command
        BNE .skip_anim          ;exit if not fight command
        LDA #$26                ;dice command
        STA $B5                 ;setup dice command for animation
.skip_anim

    ;exit
        RTL

warnpc  $C3FB80
